function [irf,ra,im]=TvcSignIdentFixedCoefCanovaGambetti2008(cholimp,nshocks,ho,maxdraws)
[n n nlagsimp draws]=size(cholimp);
dr=1;
irf=[];
ra=[];
im=[];
while dr<=maxdraws
    ext=fix(size(cholimp,4)*rand(1,1))+1;
    if nshocks>1
        a=normrnd(0,1,n,n);
        % Compute the qr decomposition associated to a
        [q r]=qr(a);
        for ii=1:n;
            if r(ii,ii)<0
                q(:,ii)=-q(:,ii);
            end
        end
        % Compute the decomposition implied by q
        for j=1:nshocks
            for i = 1:ho
                S(:,j,i) = cholimp(:,:,i,ext)*q(:,j);
            end
        end
        invchol=inv(cholimp(:,:,1,ext));
        imp=q(:,1)'*invchol(:,1);
    elseif nshocks==1
        a=normrnd(0,1,n,1);
        q=a/norm(a);
        for i = 1:ho
            S(:,1,i) = cholimp(:,:,i,ext)*q;
        end
        invchol=inv(cholimp(:,:,1,ext));
        imp=q'*invchol(:,1);
    end

    %Check the restrictions

    %%%%% First shock

    %%% monetary policy shock
    z1=[squeeze(S(1,1,1:ho))'>=0 ...
        squeeze(S(2,1,1:ho))'<=0 ...
        squeeze(S(3,1,1:ho))'<=0 ...
        squeeze(S(4,1,1:ho))'<=0 ...
        imp>0];
    zz1=sum(z1);
    if zz1<size(z1,2)
        mz1=[squeeze(S(1,1,1:ho))'<=0 ...%
            squeeze(S(2,1,1:ho))'>=0 ...
            squeeze(S(3,1,1:ho))'>=0 ...
            squeeze(S(4,1,1:ho))'>=0 ...
            imp<0];
        mzz1=sum(mz1);
        if mzz1==size(mz1,2)
            q(:,1)=-q(:,1);
        elseif mzz1<size(mz1,2)
            break
        end
    end

    %%%%% Comment out the following lines if you want to identify all
    %%%%% shocks
    %%%% Second shock
%     z2 = [squeeze(S(1,2,1:ho))'>=0 ...
%         squeeze(S(2,2,1:ho))'>=0 ...
%         squeeze(S(3,2,1:ho))'>=0 ...
%         squeeze(S(4,2,1:ho))'>=0];
%     zz2=sum(z2);
%     if zz2<size(z2,2)
%         mz2 = [squeeze(S(1,2,1:ho))'<=0 ...
%             squeeze(S(2,2,1:ho))'<=0 ...
%             squeeze(S(3,2,1:ho))'<=0 ...
%             squeeze(S(4,2,1:ho))'<=0];
%         mzz2=sum(mz2);
%         if mzz2==size(mz2,2)
%             q(:,2)=-q(:,2);
%         elseif mzz2<size(mz2,2)
%             break
%         end
%     end
% 
%     %%%% Third shock
%     z3 = [squeeze(S(1,3,1:ho))'<=0 ...
%         squeeze(S(2,3,1:ho))'<=0 ...
%         squeeze(S(3,3,1:ho))'>=0 ...
%         squeeze(S(4,3,1:ho))'<=0];
%     zz3=sum(z3);
% 
%     if zz3<size(z3,2)
%         mz3 = [squeeze(S(1,3,1:ho))'>=0 ...
%             squeeze(S(2,3,1:ho))'>=0 ...
%             squeeze(S(3,3,1:ho))'<=0 ...
%             squeeze(S(4,3,1:ho))'>=0];
%         mzz3=sum(mz3);
%         if mzz3==size(mz3,2)
%             q(:,3)=-q(:,3);
%         elseif mzz3<size(mz3,2)
%             break
%         end
%     end
    for j=1:nshocks
        for i = 1:nlagsimp
            irf(:,j,i,dr) = cholimp(:,:,i,ext)*q(:,j);
        end
    end
    if nshocks==1
        imp=q'*invchol(:,1);
    else
        imp=q(:,1)'*invchol(:,1);
    end
    aa = a;
    ra(:,:,dr) = q;
    im(dr)=imp;
    ind(dr)=ext;
    dr=dr+1;
end


