function [my1,my2,coeff1,coeff2]=TvcSystIrf(theta,Q,R,H,x,p,n,c,T,indx,MaxRep);
%a=zeros(p*n+1,1);
%a=zeros(length(indx),1);
for dr=1:800
    %dr
    Sigma11 = Q(:,:,dr);
    Sigma12 = Q(:,:,dr)*kron(H(:,1,dr)'*chol(R(:,:,dr))',eye(n*p+c))';
    %Sigma21 = Sigma12';
    Sigma22 = kron(H(:,1,dr)'*chol(R(:,:,dr))',eye(n*p+c))*Q(:,:,dr)...
        *(kron(H(:,1,dr)'*chol(R(:,:,dr))',eye(n*p+c)))';
%     a([indx])=[0 sqrt(Sigma22(3,3)) 0 sqrt(Sigma22(7,7))];%/2;
%     Mu = Sigma12(:,indx)*inv(Sigma22(indx,indx))*a(indx);
    
    a=[0 sqrt(Sigma22(3,3)) 0 sqrt(Sigma22(7,7))]';%/2;
    Mu = Sigma12(:,indx)*inv(Sigma22(indx,indx))*a;

    
    Sigma = Sigma11-Sigma12(:,indx)*inv(Sigma22(indx,indx))*Sigma12(:,indx)';
    
    [u d v] = svd(Sigma);
    SS = u*sqrt(d)*v';
    S = real(SS);

    for rep=1:MaxRep
        for t=1:T
            roo1=1;
            roo2=1;
            if t==1;
                c0=[theta(1:n*p+c:end,t,dr); theta(1:n*p+c:end,t,dr)];
                y(:,t)=x(2:end);%-c0;
                while roo1==1
                    u1=Mu+S*randn(size(S,1),1);
                    u2=mvnrnd(zeros(size(Q,1),1),Q(:,:,dr),1)';

                    th1(:,t,rep)=theta(:,:,dr)+u1;
                    th2(:,t,rep)=theta(:,:,dr)+u2;

                    a1=companion(th1(:,t,rep),p,n,c);
                    a2=companion(th2(:,t,rep),p,n,c);
                    if (max(abs(eig(a1))))<1.0 & (max(abs(eig(a2))))<1.0
                        c1=[th1(1:n*p+c:end,t,rep); zeros(n*(p-1),1)];
                        c2=[th2(1:n*p+c:end,t,rep); zeros(n*(p-1),1)];

                         y1(:,t+1,rep)=c1+a1*y(:,t);
                         y2(:,t+1,rep)=c2+a2*y(:,t);
%                         y1(:,t+1,rep)=a1*y(:,t);
%                         y2(:,t+1,rep)=a2*y(:,t);

                        roo1=0;
                    else
                        roo1=1;
                    end
                end
            else
                while roo2==1
                    %u2=mvnrnd(zeros(size(Q,1),1),Q(:,:,dr),1)';  
                    u2=0;  
                    %u1=S*randn(size(S,1),1);
                    u1=u2;
                    th1(:,t,rep)=th1(:,t-1,rep)+u1;
                    th2(:,t,rep)=th2(:,t-1,rep)+u2;

                    % compute companion matrices
                    a1=companion(th1(:,t,rep),p,n,c);
                    a2=companion(th2(:,t,rep),p,n,c);

                    % check roots
                    if (max(abs(eig(a1))))<1.0& (max(abs(eig(a2))))<1.0
                        c1=[th1(1:n*p+c:end,t,rep); zeros(n*(p-1),1)];
                        c2=[th2(1:n*p+c:end,t,rep); zeros(n*(p-1),1)];

                        y1(:,t+1,rep)=c1+a1*y1(:,t,rep);
                        y2(:,t+1,rep)=c2+a2*y2(:,t,rep);
%                         y1(:,t+1,rep)=a1*y1(:,t,rep);
%                         y2(:,t+1,rep)=a2*y2(:,t,rep);

                        roo2=0;
                    else
                        roo2=1;
                    end
                end
            end
        end
    end
    % compute E(y | I1) and E(y | I2) and coefficients
    my1(:,:,dr)=squeeze(mean(y1(1:n,2:end,:),3));
    my2(:,:,dr)=squeeze(mean(y2(1:n,2:end,:),3));
    coeff1(:,dr)=squeeze(mean(th1(:,1,:),3));
    coeff2(:,dr)=squeeze(mean(th2(:,1,:),3));
end

